#include <avr/io.h>
#include <util/delay.h>
#include <stdlib.h>
#include <math.h>
#include <avr/interrupt.h>
#include "hd44780.h"
#include "ds18b20.h"

char g_buffer[16];

//prototypes
int main (void);
void main_init(void);
//Functions

int main (void)
{
	double d = 0;
	int d1;
	int d2;
	
	_delay_ms(100);
	
	main_init();
	lcd_init();
	
	sei();
	
	OCR2B = 0;

	for (;;) {
		d = ds18b20_gettemp();
		d1=(int)floor(d);
		d2=(int)floor(d*10);
		d2=d2-d1*10;

		lcd_goto(0);
		sprintf(g_buffer,"%d.%01d ", d1,d2); 
		lcd_puts(g_buffer);

		lcd_goto(0x40);
		if (d<30)
		{
			OCR2B = 0;
			lcd_puts("     off");
		}
		else if (d<35)
		{
			if (OCR2B==0)
			{
				OCR2B = 150;
				_delay_ms(500);
				OCR2B = 120;
			}
			else
			{
				OCR2B = 110;
			}
			lcd_puts("    slow");
		}
		else if (d<40)
		{
			OCR2B = 180;
			lcd_puts("  medium");
		}
		else
		{
			OCR2B = 255;
			lcd_puts("    fast");
		}

		_delay_ms(500);
	}
	
    return(0);
}


/************************************************** Initialisations **************************************************/

void main_init(void)
{
	
    DDRC  = 0b11111111;
    DDRD  = 0b11111010;
	PORTD = 0b00001101;
	
	TCCR2A = _BV(COM2A1) | _BV(COM2B1) | _BV(WGM21) | _BV(WGM20);
	TCCR2B = _BV(CS20); 
	

	sei();
}

